--- bash-1.tex.orig	2009-07-08 15:07:34.000000000 +0200
+++ bash-1.tex	2009-07-08 16:29:13.000000000 +0200
@@ -54,7 +54,7 @@
 \chapter{Interaction d'une commande avec son shell}
 
 \section{Entres et sorties}
-Sous UNIX chaque commande utilisateur lance est attache   un shell. Dmarrez un terminal, dmarrez un programme, fermez le terminal, votre programme se fermera galement. 
+Sous UNIX chaque commande utilisateur lance depuis un shell est attache  ce mme shell. Dmarrez un terminal, dmarrez un programme, fermez le terminal, votre programme se fermera galement ( moins qu'il ne se soit dtach ;)). 
 Le programme fait plusieurs choses :
 \begin{itemize}
 \item ce pour quoi il est prvu ;
@@ -63,24 +63,67 @@
 
 \sautligne
 
-Pour crire et lire en utilisant le terminal, on utilisant 3 pseudo fichiers particuliers (appels descripteurs de fichiers) :
-\begin{itemize}
-\item \emph{stdin} (entre standard, gnralement le clavier), galement not 0 ;
-\item \emph{stdout} (sortie standard, gnralement l'cran), galement not 1 ;
-\item \emph{stderr} (sortie d'erreur, qui utilise en gnral l'cran comme \emph{stdout}, et sert   diffuser des messages d'erreur), galement not 2.
-\end{itemize}
+Pour crire et lire en utilisant le terminal, on utilise 3 pseudo fichiers particuliers (appels descripteurs de fichiers):
+\begin{description}
+\item[stdin] entre standard, gnralement le clavier, galement not 0;
+\item[stdout] sortie standard, gnralement l'cran, galement not 1;
+\item[stderr] sortie d'erreur, qui utilise en gnral l'cran comme \emph{stdout}, et sert   diffuser des messages d'erreur), galement not 2.
+\end{description}
 
 \sautligne
 
-Suivant les systmes d'exploitation ou les distributions (Linux ou BSD) vous pouvez voir ces fichiers   l'aide de la commande :
-\begin{lstlisting}[lastline=1]
-$ ls /dev/pts/ 
-$
+% Suivant les systmes d'exploitation ou les distributions (Linux ou BSD) vous pouvez voir ces fichiers   l'aide de la commande :
+%% /dev/pts/ n'existe mme pas sous OpenBSD ;)
+% \begin{lstlisting}[lastline=1]
+% $ ls /dev/pts/ 
+% $
+% \end{lstlisting}
+
+Sous Linux vous pouvez voir ces fichiers en affichant les descripteurs associs
+ votre shell. Dans votre shell tapez la commande suivante:
+
+\begin{lstlisting}
+$ ls -l /proc/$$/fd
+total 0
+lrwx------ 1 user user 64 2009-07-08 15:14 0 -> /dev/pts/4
+lrwx------ 1 user user 64 2009-07-08 15:14 1 -> /dev/pts/4
+lrwx------ 1 user user 64 2009-07-08 15:14 2 -> /dev/pts/4
+lrwx------ 1 user user 64 2009-07-08 15:14 255 -> /dev/pts/4
 \end{lstlisting}
-
 \sautligne
 
-Voici quelques exemples : 
+Ceci liste donc les \emph{f(ile) d(escriptors)} associs au processus courant
+(variable \$\$). Le \emph{fd} 255 est un cas particulier associ au
+fonctionnement de \emph{bash}, votre shell par dfaut sous Linux.
+
+En ce qui concerne \verb+/dev/pts/4+, il s'agit tout simplement de
+l'identifiant de votre terminal, ici il s'agit du pseudo terminal 4. La liste
+des pseudos terminaux ouverts se trouve dans le dossier \verb+/dev/pts+. Il est
+galement possible de savoir  quel terminal sont associs des processus, par
+exemple avec la commande:
+
+\begin{lstlisting}
+$ ps a -o command,tty
+COMMAND                     TT
+/sbin/getty 38400 tty1      tty1
+/sbin/getty 38400 tty2      tty2
+/sbin/getty 38400 tty3      tty3
+/sbin/getty 38400 tty4      tty4
+/sbin/getty 38400 tty5      tty5
+/sbin/getty 38400 tty6      tty6
+/usr/X11R6/bin/X -auth /var tty7
+bash                        pts/3
+vi bash-1.tex               pts/3
+bash                        pts/5
+ps a -o command,tty         pts/5
+\end{lstlisting}
+
+Les lignes correspondant  \verb+tty1+  \verb+tty6+ sont en fait des \emph{tty}
+"physiques", ceux auxquels vont accdez par les combinaisons de touches
+\emph{Ctrl+Alt+FX}. \verb+tty7+ est un cas particulier qui ici est utilis par
+mon serveur X pour afficher une interface graphique.
+
+Aprs cette digression, continuons avec quelques exemples:
 \begin{itemize}
 \item Lorsque vous entrez votre login dans un tty (pas dans gdm ou kdm), le programme 'login' lit vos donnes sur \emph{stdin}.
 \item Le programme 'ls' utilise \emph{stdout} ou \emph{stderr} suivant ce qu'il a   dire :
@@ -95,7 +138,7 @@
 
 \section{Redirection de flux}
 
-La commande prcdente redirige la sortie de \verb+ls+ sur \emph{stdout}, en gnral il s'agit de l'cran. Mais il est possible de rediriger la sortie ailleurs que sur l'cran. La 'redirection de flux' s'effectue gre   l'oprateur '$>$' :
+La commande prcdente redirige la sortie de \verb+ls+ sur \emph{stdout}, en gnral il s'agit de l'cran. Mais il est possible de rediriger la sortie ailleurs que sur l'cran. La 'redirection de flux' s'effectue grce   l'oprateur '$>$' :
 \begin{lstlisting}[lastline=1]
 $ ls 1>/dev/null	#1 (donc stdout) est redirige vers /dev/null
 $
@@ -103,7 +146,7 @@
 
 \sautligne
 
-Rien n'est alors list sur le terminal. Le rsultat de \verb+ls+ est crit dans le fichier spcial /dev/null (c'est un fichier de type 'caractre' qui se contente d'absorber ce qu'on lui envoie sans rien redonner).
+Rien n'est alors list sur le terminal. Le rsultat de \verb+ls+ est crit dans le fichier spcial \verb+/dev/null+ (c'est un fichier de type 'caractre' qui se contente d'absorber ce qu'on lui envoie sans rien redonner).
 
 \sautligne
 
@@ -118,7 +161,7 @@
 Les messages d'erreur de \verb+ls+ sont toujours envoys sur \emph{stderr} et la redirection prcdente n'a pas d'effet :
 \begin{lstlisting}[lastline=2]
 $ ls fichier_non_existant >/dev/null
-$ ls: cannot access fichier_non_existant: No such file or directory
+ls: cannot access fichier_non_existant: No such file or directory
 \end{lstlisting}
 
 \sautligne
@@ -143,13 +186,13 @@
 
 \Rappel{'\&1'reprsente bien \emph{stdout} lorsqu'il est plac   droite de '$>$'. Utiliser '1' sans le '\&' aurait redirig \emph{stderr} dans un fichier nomm '1'.}
 	
-A la place de /dev/null, on peut bien entendu rediriger \emph{stdout} ou \emph{stderr} vers un fichier normal. Il est mme possible de concatner (terme barabre signifiant qu'on ajoute   la suite) la sortie au contenu d'un fichier dj  existant avec '$>>$'.
+ la place de /dev/null, on peut bien entendu rediriger \emph{stdout} ou \emph{stderr} vers un fichier normal. Il est mme possible de concatner (terme barabre signifiant qu'on ajoute   la suite) la sortie au contenu d'un fichier dj  existant avec '$>>$'.
 \begin{lstlisting}[lastline=7]
 $ pwd > fichier
 $ cat fichier
 /home/gauvain
 $ date >> fichier
-$ cate fichier
+$ cat fichier
 /home/gauvain
 mardi 28 avril 2009, 00:44:19 (UTC+0200)
 \end{lstlisting}
@@ -158,7 +201,7 @@
 
 Attention toutefois   ne pas tout envoyer vers le fichier /dev/null. En effet si vous faite :
 \begin{lstlisting}[lastline=1]
-$ls fichier_non_existant >/dev/null 2>&1
+$ ls fichier_non_existant >/dev/null 2>&1
 $
 \end{lstlisting}
 
@@ -168,38 +211,95 @@
 
 Cependant si vous avez spcifi le nom d'un fichier   la place de /dev/null, dans ce cas la tous les messages seront crit dans ce fichier. Vous pouvez galement utiliser la fonction de concatnation de la redirection :
 \begin{lstlisting}[lastline=7]
-$pwd > toto
-$cat toto
+$ pwd > toto
+$ cat toto
 /home/gauvain
-$ls fichier_non_existant >>toto 2>&1
-$cat toto
+$ ls fichier_non_existant >>toto 2>&1
+$ cat toto
 /home/gauvain
 ls: cannot access fichier_non_existant: No such file or directory
 \end{lstlisting}
 
 \sautligne
 
-L'utilisation de la redirection 2$>$\&1 peut tre trs utile pour viter de retaper le nom et l'emplacement d'un fichier. Dans l'exemple prcdent, cela vous viteras de rentrer deux fois le nom du fichier toto. Cela simplifieras galement la lecture de vos scripts.
+ noter que l'valuation des redirections est ralise de droite  gauche.
+
+Prennons par exemple la commande suivante dont nous redirigerons les sorties
+d'erreur et standard.
+\begin{lstlisting}
+$ ls /etc/hostname fichierinexistant
+ls: cannot access fichierinexistant: No such file or directory
+/etc/hostname
+\end{lstlisting}
+
+Nous tentons simplement de lister le fichier \verb+/etc/hostname+ ainsi qu'un
+fichier (dans notre cas) inexistant. Deux lignes de texte sont renvoyes par
+\verb+ls+. La premire est affiche sur la sortie d'erreur, la deuxime sur la
+sorte standard. Nous allons maintenant "jouer" avec les redirections.
+
+\begin{lstlisting}
+$ ls /etc/hostname fichierinexistant >>listing 2>listing
+$ cat listing
+ls: cannot access fichierinexistant: No such file or directory
+/etc/hostname
+\end{lstlisting}
+
+Rappelons que l'oprateur $>$ tronque d'abord le fichier (le ramne  une
+taille de 0 et le cre si besoin est) avant d'crire le contenu redirig.
+En allant de droite  gauche donc, le fichier listing est tronqu, et la sortie
+d'erreur redirige vers celui-ci, ensuite la sortie standard est redirige vers
+ce mme fichier, mais en tant ajoute  la suite (tel qu'expliqu pour
+l'oprateur $>>$ ).
+
+Autre exemple maintenant:
+\begin{lstlisting}
+$ rm listing
+$ ls /etc/hostname fichierinexistant >listing 2>listing
+$ cat listing
+/etc/hostname
+ess fichierinexistant: No such file or directory
+\end{lstlisting}
+
+Ici un comportement assez trange sans vraiment l'tre. De droite  gauche, la
+sortie d'erreur est redirige vers le fichier \verb+listing+ mais c'est
+galement le cas de la sortie standard. Les deux critures vont donc se
+raliser "en paralllle" en dbut de fichier \verb+listing+ . Comme la sortie
+d'erreur est non bufferise elle sera la premire  tre crite dans le fichier
+et par-dessus sera ensuite crit la sortie standard, ce qui explique ce bout de
+message manquant (vous remarquerez que le bout de message manquant fait
+exactement la taille de la chane de caractre mise par la sortie standard, en
+n'oubliant par le retour  la ligne).
+
+\begin{lstlisting}
+/etc/hostname
+             ess fichierinexistant: No such file or directory
+\end{lstlisting}
+
+Il s'agit bien entendu de cas extrmes et extrmement peu utiliss, mais il est
+bon d'y faire attention lors de l'utilisation de redirections multiples.
+
+%L'utilisation de la redirection 2$>$\&1 peut tre trs utile pour viter de retaper le nom et l'emplacement d'un fichier. Dans l'exemple prcdent, cela vous vitera de rentrer deux fois le nom du fichier \verb+toto+. Cela simplifiera galement la lecture de vos scripts.
+
 
 \section{Codes de retour des commandes}
 
-Les codes de retour des commandes n'ont que peu d'intrt, et ils n'indiquent ni l'chec complet ni la russite du programme. Le code de retour du programme donne plus d'informations. Lorsque le programme a fini sont excution, une variable particulire qui contient le code de retour est disponible : \$?
+Les messages de la sortie d'erreur n'ont qu'un intrt indicatif pour l'utilisateur, ils n'indiquent ni l'chec complet ni la russite du programme.  ce niveau le code de retour du programme donne plus d'informations. Lorsque le programme a fini sont excution, une variable particulire qui contient le code de retour est disponible : \$? .
 
-Sa valeur peut tre affiche gre   la commande \verb+echo+. Ds qu'une autre commande est termine, sa valeur change, donc le rsultat est dpendant de ce qui se passe prcdemment :
+Sa valeur peut tre affiche grce  la commande \verb+echo+. Ds qu'une autre commande est termine, sa valeur change, donc le rsultat est dpendant de ce qui se passe prcdemment :
 \begin{lstlisting}[lastline=8]
 $ ls
 fichier_1 fichier_2 fichier_3
 $ echo $?
-1		#(ls a reussi a faire ce qu'on lui demande)
+0		#(ls n'a pas rencontr d'erreur pendant son excution)
 $ ls fichier_non_existant
 ls: cannot access fichier_non_existant: No such file or directory
 $ echo $?
-0		#(ls n'a pas reussi a faire ce qu'on lui demande)
+2		#(ls a rencontr une ou plusieurs erreurs pendant son excution)
 \end{lstlisting}
 
 \sautligne
 
-Les diffrents codes retourn peuvent tre :
+Les diffrents codes retourns peuvent tre :
 \begin{itemize}
 \item 0 est le code de retour conventionnel lorsqu'une application quitte en ayant fonctionn correctement ;
 \item Les codes de retour suprieurs   0 indiquent qu'une erreur s'est produite. La signification dpend du programme ;
@@ -217,9 +317,9 @@
 
 Les entres/sorties ainsi que le code de retour sont au bon vouloir du programmeur. Mais la convention veut que le code retour en cas de succs d'un programme soit toujours 0 (c'est le fameux return 0; des fonctions main dans un programme en C/C++/C\#). 
 
-\section{Interaction entres plusieurs commandes}
+\section{Interaction entre plusieurs commandes}
 
-Il est possible d'excuter 2 commandes   la suite en les sparant par le symbole ';'. La $2^{nde}$ commande sera alors excute quel que soit le code de retour de la $1^{ere}$.
+Il est possible d'excuter 2 commandes   la suite en les sparant par le symbole ';'. La $2^{nde}$ commande sera alors excute quel que soit le code de retour de la $1^{re}$.
 Par exemple
 \begin{lstlisting}[lastline=3]
 $ ls toto; cd toto
@@ -232,7 +332,7 @@
 
 Comme vous pouvez le voir les 2 commandes ont t excutes et ont chou.
 
-Pour permettre un meilleur contrle sur l'enchainement de deux (ou plus) commandes il existe deux oprateurs. Les oprateurs \&\& et $||$ autorisent l'excution conditionnelle d'une commande suivant la valeur du code de retour de la commande prcdente.
+Pour permettre un meilleur contrle sur l'enchanement de deux (ou plusieurs) commandes il existe deux oprateurs. Les oprateurs \&\& et $||$ autorisent l'excution conditionnelle d'une commande suivant la valeur du code de retour de la commande prcdente.
 
 L'oprateur \&\& n'excute la commande de droite que si celle de gauche a un code de retour gal   0 (donc si elle s'est correctement termine).
 Par exemple :
@@ -257,9 +357,9 @@
 
 \sautligne
 
-Le message envoy par le \verb+echo+ s'affiche car la $1^{ere}$ commande a chou.
+Le message envoy par le \verb+echo+ s'affiche car la $1^{re}$ commande a chou.
 
-Il est bien entendu possible de chaner autant d'oprateurs \&\& et $||$ que l'on dsire et mme de les mlanger dans une mme ligne de commande. Les 2 oprateurs ont la mme priorit et leur valuation s'effectue de gauche   droite. Mais vous devez prudent et connatre par avance le rsultat de vos commande pour enchaner correctement les commandes suivantes. 
+Il est bien entendu possible de chaner autant d'oprateurs \&\& et $||$ que l'on dsire et mme de les mlanger dans une mme ligne de commande. Les 2 oprateurs ont la mme priorit et leur valuation s'effectue de gauche   droite. Mais vous devez tre prudent et connatre par avance le rsultat de vos commande pour enchaner correctement les commandes suivantes. 
 Voici quelques exemples d'enchainements :
 \begin{lstlisting}[lastline=25]
 $ toto && tata || echo 'titi'
@@ -335,22 +435,23 @@
 Cette $2^{nde}$ notation est utile en cas de concatnation d'une variable avec un texte ou une autre variable :
 \begin{lstlisting}[lastline=3]
 $ arbre=sapin
-$ echo 'un $arbre, des $arbres'
+$ echo "un $arbre, des $arbres"
 un sapin, des
 \end{lstlisting}
 
 \sautligne
 
 Comme vous pouvez le constater, il manque une partie de la phrase. Cela est d au fait que pour le shell la variable \$arbres n'existe pas. Le shell la remplace donc par un blanc. Alors que :
+
 \begin{lstlisting}[lastline=2]
-$ echo 'un $arbre, des ${arbre}s'
+$ echo "un $arbre, des ${arbre}s"
 un sapin, des sapins
 $
 \end{lstlisting}
 
 \sautligne
 
-Cette vois ci c'est bien \$arbre qui est utilis et remplac par sa valeur : sapin.
+Cette fois ci c'est bien \$arbre qui est utilis et remplac par sa valeur : sapin.
 
 Il faut faire attention   certaines rgles :
 \begin{itemize}
@@ -378,11 +479,21 @@
 
 \sautligne
 
-Les expressions entoures de " " ou ' ' sont interprtes comme un tout. C'est un lment particulirement important, notamment pour comprendre comme sont interprts les arguments passs aux scripts. Dans ce cas, le caractre espace n'est plus considr comme un sparateur de commande, mais comme faisant partie de la chane affecte   la variable "FOO".
+Les expressions entoures de " " ou ' ' sont considres comme un tout, une chane de caractre complte.  noter que seul les expressions entoures de double quote ("") seront interprtes pour les variables ou expansions qu'elle contiennent.
+
+\begin{lstlisting}
+$ arbre=sapin
+$ echo 'un $arbre, des ${arbre}s'
+un $arbre, des ${arbre}s
+$ echo "un $arbre, des ${arbre}s"
+un sapin, des sapins
+\end{lstlisting}
+
+C'est un lment particulirement important, notamment pour comprendre comment sont interprts les arguments passs aux scripts. Dans ce cas, le caractre espace n'est plus considr comme un sparateur de commande, mais comme faisant partie de la chane affecte   la variable "FOO".
 
 Les variables sont de type \og string\fg mais peuvent tres \og casts\fg en entier quand il est ncessaire. Cependant les diffrents shell (bash, csh, zsh, etc.) peuvent tendre le type possible de variable (comme par exemple, un type \og array\fg pour un shell bash). 
 
-Une autre possibilit est d'utiliser le backslash '\backslash', qui est un caractre dit \og d'chappement\fg. Plac devant un caractre spcial, il permet de le traiter comme un caractre normal. En reprenant l'exemple prcdent :
+Une autre possibilit est d'utiliser le backslash '\backslash', qui est un caractre dit \og d'chappement\fg. Plac devant un caractre spcial, il permet de le trater comme un caractre normal. En reprenant l'exemple prcdent :
 \begin{lstlisting}[lastline=3]
 $ FOO=bar\ baz
 $ echo $FOO
@@ -418,15 +529,15 @@
 
 \section{Les commandes set et unset}
 
-La commande \verb+set+ permet de visualiser toutes les variables dfinies pour le shell (variables au sens large, vous risquez d'tre surpris si vous excutez cette commande).
+La commande \verb+set+ permet de visualiser toutes les variables dfinies pour le shell (variables et mme fonctions au sens large, vous risquez d'tre surpris si vous excutez cette commande).
 
 La commande \verb+unset+ permet de supprimer une variable :
 \begin{lstlisting}[lastline=6]
 $ arbre=sapin
-$ echo 'un $arbre est un arbre' 
+$ echo "un $arbre est un arbre"
 un sapin est un arbre	# $arbre est bien remplace ici par 'sapin'
 $ unset arbre
-$ echo 'un $arbre est un arbre'
+$ echo "un $arbre est un arbre"
 un  est un arbre
 $
 \end{lstlisting}
@@ -446,9 +557,9 @@
 $ export arbre=sapin
 $ animal=chien
 $ bash			# On lance un nouveau shell depuis le shell courant
-$ echo 'un $arbre est un arbre'
+$ echo "un $arbre est un arbre"
 un sapin est un arbre	# $arbre a bien t rendu accessible au le sous-shell
-$ echo 'un $animal est un animal'
+$ echo "un $animal est un animal"
 un est un animal	# $animal ne renvoie rien car non export au sous-shell 
 $
 \end{lstlisting}
@@ -475,7 +586,7 @@
 
 \sautligne
 
-Le conteneur 'SHELL' a donc la valeur '/bin/bash' (qui est l'interprteur shell sur ma machine. Cette valeur peut tre diffrente sur d'autre machine). Certaines de ces variables sont dfinies par le shell lui mme (SHELL par exemple), certaines dans son fichier de configuration, d'autres par des logiciels tiers (XAUTHORITY pour X) ou encore manuellement (DEBEMAIL).
+Le conteneur 'SHELL' a donc la valeur '/bin/bash' (qui est l'interprteur shell sur ma machine. Cette valeur peut tre diffrente sur d'autres machines). Certaines de ces variables sont dfinies par le shell lui mme (SHELL par exemple), certaines dans son fichier de configuration, d'autres par des logiciels tiers (XAUTHORITY pour X) ou encore manuellement (DEBEMAIL).
 
 \section{Mixer variables et commandes}
 
@@ -559,7 +670,7 @@
 
 \sautligne
 
-La commande \verb+ls+ va lister tous les fichiers et va les afficher sur la sortie standard (\emph{stdout}). Le `pipe` (tuyau, not $|$ ) va alors rcuprer la sortie et la renvoyer vers l'entre standard (\emph{stdin}). La commande \verb+grep+ prend alors le relais pour n'afficher que les fichiers ne terminant pas par .pdf.
+La commande \verb+ls+ va lister tous les fichiers et va les afficher sur la sortie standard (\emph{stdout}). Le `pipe` (tuyau, not $|$ ) va alors rcuprer la sortie et la renvoyer vers l'entre standard (\emph{stdin}). La commande \verb+grep+ prend alors le relai pour n'afficher que les fichiers ne terminant pas par .pdf.
 
 Le mcanisme des pipes ($|$) permet d'enchaner plusieurs commandes, en connectant la sortie standard d'une commande   l'entre standard de la suivante. Cela permet par exemple d'enchaner plusieurs commandes pour enregistrer le rsultat final dans une variable :
 \begin{lstlisting}[lastline=2]
@@ -589,8 +700,8 @@
 %%%%%%%%%%%%%%
 \chapter{Conclusion}
 
-Avec ce premier cours nous avons un fait tour rapide des possibilits d'utilisation du shell au travers de principes importants et fondamentales pour l'criture et la comprhension de script shell.
-Les autres possibilits du shell sont trop nombreuses pour tre toute explique dans ce cours, je vous invite donc   consulter le document en annexe qui vous donnera des informations additionnelles.
+Avec ce premier cours nous avons un fait tour rapide des possibilits d'utilisation du shell au travers de principes importants et fondamentaux pour l'criture et la comprhension de scripts shell.
+Les autres possibilits du shell sont trop nombreuses pour tre toutes expliques dans ce cours, je vous invite donc   consulter le document en annexe qui vous donnera des informations additionnelles.
 
 Pour finir, voici quelques liens internet o vous pourrez trouver de plus amples informations :
 
